// Generated by CoffeeScript 1.3.3
(function() {

  define(['d3'], function() {
    var AreaLayout;
    return AreaLayout = (function() {

      function AreaLayout(options) {
        this.svg = options.svg, this.xScale = options.xScale, this.yScale = options.yScale, this.symbols = options.symbols, this.generators = options.generators, this.color = options.color, this.height = options.height, this.width = options.width, this.duration = options.duration, this.delay = options.delay, this.onAnimationEnd = options.onAnimationEnd;
        this.prepareSymbols();
      }

      AreaLayout.prototype.prepareSymbols = function() {
        var symbolNodes,
          _this = this;
        symbolNodes = this.svg.selectAll('.symbol');
        this.generators.axis.y(this.height / 4 - 21);
        symbolNodes.select('.line').attr('d', function(d) {
          return _this.generators.axis(d.values);
        });
        symbolNodes.each(function(d, i, j) {
          var node;
          node = symbolNodes[j][i];
          _this.yScale.domain([0, d.maxPrice]);
          d3.select(node).select('.line').transition().duration(_this.duration).style('stroke-opacity', 1).each('end', function() {
            return d3.select(this).style('stroke-opacity', null);
          });
          d3.select(node).selectAll('.area').filter(function(d, i) {
            return i;
          }).transition().duration(_this.duration).style('fill-opacity', 1e-6).attr('d', _this.generators.area(d.values)).remove();
          return d3.select(node).selectAll('.area').filter(function(d, i) {
            return !i;
          }).transition().duration(_this.duration).style('fill', _this.color(d.key)).attr('d', _this.generators.area(d.values));
        });
        this.svg.select('defs').transition().duration(this.duration).remove();
        symbolNodes.transition().duration(this.duration).each("end", function() {
          return d3.select(this).attr('clip-path', null);
        });
        return setTimeout(this.onAnimationEnd, this.duration + this.delay);
      };

      return AreaLayout;

    })();
  });

}).call(this);
